# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['AttachmentArgs', 'Attachment']

@pulumi.input_type
class AttachmentArgs:
    def __init__(__self__, *,
                 file: pulumi.Input[str],
                 item_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a Attachment resource.
        :param pulumi.Input[str] file: Path to the content of the attachment.
        :param pulumi.Input[str] item_id: Identifier of the item the attachment belongs to
        """
        pulumi.set(__self__, "file", file)
        pulumi.set(__self__, "item_id", item_id)

    @property
    @pulumi.getter
    def file(self) -> pulumi.Input[str]:
        """
        Path to the content of the attachment.
        """
        return pulumi.get(self, "file")

    @file.setter
    def file(self, value: pulumi.Input[str]):
        pulumi.set(self, "file", value)

    @property
    @pulumi.getter(name="itemId")
    def item_id(self) -> pulumi.Input[str]:
        """
        Identifier of the item the attachment belongs to
        """
        return pulumi.get(self, "item_id")

    @item_id.setter
    def item_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "item_id", value)


@pulumi.input_type
class _AttachmentState:
    def __init__(__self__, *,
                 file: Optional[pulumi.Input[str]] = None,
                 file_name: Optional[pulumi.Input[str]] = None,
                 item_id: Optional[pulumi.Input[str]] = None,
                 size: Optional[pulumi.Input[str]] = None,
                 size_name: Optional[pulumi.Input[str]] = None,
                 url: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Attachment resources.
        :param pulumi.Input[str] file: Path to the content of the attachment.
        :param pulumi.Input[str] file_name: File name
        :param pulumi.Input[str] item_id: Identifier of the item the attachment belongs to
        :param pulumi.Input[str] size: Size in bytes
        :param pulumi.Input[str] size_name: Size as string
        :param pulumi.Input[str] url: URL
        """
        if file is not None:
            pulumi.set(__self__, "file", file)
        if file_name is not None:
            pulumi.set(__self__, "file_name", file_name)
        if item_id is not None:
            pulumi.set(__self__, "item_id", item_id)
        if size is not None:
            pulumi.set(__self__, "size", size)
        if size_name is not None:
            pulumi.set(__self__, "size_name", size_name)
        if url is not None:
            pulumi.set(__self__, "url", url)

    @property
    @pulumi.getter
    def file(self) -> Optional[pulumi.Input[str]]:
        """
        Path to the content of the attachment.
        """
        return pulumi.get(self, "file")

    @file.setter
    def file(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "file", value)

    @property
    @pulumi.getter(name="fileName")
    def file_name(self) -> Optional[pulumi.Input[str]]:
        """
        File name
        """
        return pulumi.get(self, "file_name")

    @file_name.setter
    def file_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "file_name", value)

    @property
    @pulumi.getter(name="itemId")
    def item_id(self) -> Optional[pulumi.Input[str]]:
        """
        Identifier of the item the attachment belongs to
        """
        return pulumi.get(self, "item_id")

    @item_id.setter
    def item_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "item_id", value)

    @property
    @pulumi.getter
    def size(self) -> Optional[pulumi.Input[str]]:
        """
        Size in bytes
        """
        return pulumi.get(self, "size")

    @size.setter
    def size(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "size", value)

    @property
    @pulumi.getter(name="sizeName")
    def size_name(self) -> Optional[pulumi.Input[str]]:
        """
        Size as string
        """
        return pulumi.get(self, "size_name")

    @size_name.setter
    def size_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "size_name", value)

    @property
    @pulumi.getter
    def url(self) -> Optional[pulumi.Input[str]]:
        """
        URL
        """
        return pulumi.get(self, "url")

    @url.setter
    def url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "url", value)


class Attachment(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 file: Optional[pulumi.Input[str]] = None,
                 item_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Manages an item attachment.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_bitwarden as bitwarden

        vpn_credentials = bitwarden.ItemLogin("vpnCredentials", username="admin")
        vpn_config = bitwarden.Attachment("vpnConfig",
            file="vpn-config.txt",
            item_id=vpn_credentials.id)
        ```

        ## Import

        ```sh
        $ pulumi import bitwarden:index/attachment:Attachment example <item_id>/<attachment_id>
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] file: Path to the content of the attachment.
        :param pulumi.Input[str] item_id: Identifier of the item the attachment belongs to
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AttachmentArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Manages an item attachment.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_bitwarden as bitwarden

        vpn_credentials = bitwarden.ItemLogin("vpnCredentials", username="admin")
        vpn_config = bitwarden.Attachment("vpnConfig",
            file="vpn-config.txt",
            item_id=vpn_credentials.id)
        ```

        ## Import

        ```sh
        $ pulumi import bitwarden:index/attachment:Attachment example <item_id>/<attachment_id>
        ```

        :param str resource_name: The name of the resource.
        :param AttachmentArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AttachmentArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 file: Optional[pulumi.Input[str]] = None,
                 item_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AttachmentArgs.__new__(AttachmentArgs)

            if file is None and not opts.urn:
                raise TypeError("Missing required property 'file'")
            __props__.__dict__["file"] = file
            if item_id is None and not opts.urn:
                raise TypeError("Missing required property 'item_id'")
            __props__.__dict__["item_id"] = item_id
            __props__.__dict__["file_name"] = None
            __props__.__dict__["size"] = None
            __props__.__dict__["size_name"] = None
            __props__.__dict__["url"] = None
        super(Attachment, __self__).__init__(
            'bitwarden:index/attachment:Attachment',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            file: Optional[pulumi.Input[str]] = None,
            file_name: Optional[pulumi.Input[str]] = None,
            item_id: Optional[pulumi.Input[str]] = None,
            size: Optional[pulumi.Input[str]] = None,
            size_name: Optional[pulumi.Input[str]] = None,
            url: Optional[pulumi.Input[str]] = None) -> 'Attachment':
        """
        Get an existing Attachment resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] file: Path to the content of the attachment.
        :param pulumi.Input[str] file_name: File name
        :param pulumi.Input[str] item_id: Identifier of the item the attachment belongs to
        :param pulumi.Input[str] size: Size in bytes
        :param pulumi.Input[str] size_name: Size as string
        :param pulumi.Input[str] url: URL
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AttachmentState.__new__(_AttachmentState)

        __props__.__dict__["file"] = file
        __props__.__dict__["file_name"] = file_name
        __props__.__dict__["item_id"] = item_id
        __props__.__dict__["size"] = size
        __props__.__dict__["size_name"] = size_name
        __props__.__dict__["url"] = url
        return Attachment(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def file(self) -> pulumi.Output[str]:
        """
        Path to the content of the attachment.
        """
        return pulumi.get(self, "file")

    @property
    @pulumi.getter(name="fileName")
    def file_name(self) -> pulumi.Output[str]:
        """
        File name
        """
        return pulumi.get(self, "file_name")

    @property
    @pulumi.getter(name="itemId")
    def item_id(self) -> pulumi.Output[str]:
        """
        Identifier of the item the attachment belongs to
        """
        return pulumi.get(self, "item_id")

    @property
    @pulumi.getter
    def size(self) -> pulumi.Output[str]:
        """
        Size in bytes
        """
        return pulumi.get(self, "size")

    @property
    @pulumi.getter(name="sizeName")
    def size_name(self) -> pulumi.Output[str]:
        """
        Size as string
        """
        return pulumi.get(self, "size_name")

    @property
    @pulumi.getter
    def url(self) -> pulumi.Output[str]:
        """
        URL
        """
        return pulumi.get(self, "url")

