# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetOrgCollectionResult',
    'AwaitableGetOrgCollectionResult',
    'get_org_collection',
    'get_org_collection_output',
]

@pulumi.output_type
class GetOrgCollectionResult:
    """
    A collection of values returned by getOrgCollection.
    """
    def __init__(__self__, id=None, name=None, object=None, organization_id=None, search=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if object and not isinstance(object, str):
            raise TypeError("Expected argument 'object' to be a str")
        pulumi.set(__self__, "object", object)
        if organization_id and not isinstance(organization_id, str):
            raise TypeError("Expected argument 'organization_id' to be a str")
        pulumi.set(__self__, "organization_id", organization_id)
        if search and not isinstance(search, str):
            raise TypeError("Expected argument 'search' to be a str")
        pulumi.set(__self__, "search", search)

    @property
    @pulumi.getter
    def id(self) -> Optional[str]:
        """
        Identifier.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def object(self) -> str:
        return pulumi.get(self, "object")

    @property
    @pulumi.getter(name="organizationId")
    def organization_id(self) -> str:
        """
        Identifier of the organization.
        """
        return pulumi.get(self, "organization_id")

    @property
    @pulumi.getter
    def search(self) -> Optional[str]:
        """
        Search items matching the search string.
        """
        return pulumi.get(self, "search")


class AwaitableGetOrgCollectionResult(GetOrgCollectionResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetOrgCollectionResult(
            id=self.id,
            name=self.name,
            object=self.object,
            organization_id=self.organization_id,
            search=self.search)


def get_org_collection(id: Optional[str] = None,
                       organization_id: Optional[str] = None,
                       search: Optional[str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetOrgCollectionResult:
    """
    Use this data source to get information on an existing organization collection.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_bitwarden as bitwarden

    terraform = bitwarden.get_organization(search="Terraform")
    engineering = bitwarden.get_org_collection(search="Engineering",
        organization_id=terraform.id)
    # Example of usage of the data source:
    administrative_user = bitwarden.ItemLogin("administrativeUser",
        username="admin",
        password="<sensitive>",
        organization_id=terraform.id,
        collection_ids=[data["bitwarden_org_collection"]["terraform"]["id"]])
    ```


    :param str id: Identifier.
    :param str organization_id: Identifier of the organization.
    :param str search: Search items matching the search string.
    """
    __args__ = dict()
    __args__['id'] = id
    __args__['organizationId'] = organization_id
    __args__['search'] = search
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('bitwarden:index/getOrgCollection:getOrgCollection', __args__, opts=opts, typ=GetOrgCollectionResult).value

    return AwaitableGetOrgCollectionResult(
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        object=pulumi.get(__ret__, 'object'),
        organization_id=pulumi.get(__ret__, 'organization_id'),
        search=pulumi.get(__ret__, 'search'))


@_utilities.lift_output_func(get_org_collection)
def get_org_collection_output(id: Optional[pulumi.Input[Optional[str]]] = None,
                              organization_id: Optional[pulumi.Input[str]] = None,
                              search: Optional[pulumi.Input[Optional[str]]] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetOrgCollectionResult]:
    """
    Use this data source to get information on an existing organization collection.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_bitwarden as bitwarden

    terraform = bitwarden.get_organization(search="Terraform")
    engineering = bitwarden.get_org_collection(search="Engineering",
        organization_id=terraform.id)
    # Example of usage of the data source:
    administrative_user = bitwarden.ItemLogin("administrativeUser",
        username="admin",
        password="<sensitive>",
        organization_id=terraform.id,
        collection_ids=[data["bitwarden_org_collection"]["terraform"]["id"]])
    ```


    :param str id: Identifier.
    :param str organization_id: Identifier of the organization.
    :param str search: Search items matching the search string.
    """
    ...
