# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetOrganizationResult',
    'AwaitableGetOrganizationResult',
    'get_organization',
    'get_organization_output',
]

@pulumi.output_type
class GetOrganizationResult:
    """
    A collection of values returned by getOrganization.
    """
    def __init__(__self__, id=None, name=None, object=None, search=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if object and not isinstance(object, str):
            raise TypeError("Expected argument 'object' to be a str")
        pulumi.set(__self__, "object", object)
        if search and not isinstance(search, str):
            raise TypeError("Expected argument 'search' to be a str")
        pulumi.set(__self__, "search", search)

    @property
    @pulumi.getter
    def id(self) -> Optional[str]:
        """
        Identifier.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def object(self) -> str:
        return pulumi.get(self, "object")

    @property
    @pulumi.getter
    def search(self) -> Optional[str]:
        """
        Search items matching the search string.
        """
        return pulumi.get(self, "search")


class AwaitableGetOrganizationResult(GetOrganizationResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetOrganizationResult(
            id=self.id,
            name=self.name,
            object=self.object,
            search=self.search)


def get_organization(id: Optional[str] = None,
                     search: Optional[str] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetOrganizationResult:
    """
    Use this data source to get information on an existing organization.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_bitwarden as bitwarden

    terraform = bitwarden.get_organization(search="Terraform")
    # Example of usage of the data source:
    administrative_user = bitwarden.ItemLogin("administrativeUser",
        username="admin",
        password="<sensitive>",
        organization_id=terraform.id)
    ```


    :param str id: Identifier.
    :param str search: Search items matching the search string.
    """
    __args__ = dict()
    __args__['id'] = id
    __args__['search'] = search
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('bitwarden:index/getOrganization:getOrganization', __args__, opts=opts, typ=GetOrganizationResult).value

    return AwaitableGetOrganizationResult(
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        object=pulumi.get(__ret__, 'object'),
        search=pulumi.get(__ret__, 'search'))


@_utilities.lift_output_func(get_organization)
def get_organization_output(id: Optional[pulumi.Input[Optional[str]]] = None,
                            search: Optional[pulumi.Input[Optional[str]]] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetOrganizationResult]:
    """
    Use this data source to get information on an existing organization.

    ## Example Usage

    ```python
    import pulumi
    import pulumi_bitwarden as bitwarden

    terraform = bitwarden.get_organization(search="Terraform")
    # Example of usage of the data source:
    administrative_user = bitwarden.ItemLogin("administrativeUser",
        username="admin",
        password="<sensitive>",
        organization_id=terraform.id)
    ```


    :param str id: Identifier.
    :param str search: Search items matching the search string.
    """
    ...
