# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['ProviderArgs', 'Provider']

@pulumi.input_type
class ProviderArgs:
    def __init__(__self__, *,
                 email: pulumi.Input[str],
                 server: pulumi.Input[str],
                 client_id: Optional[pulumi.Input[str]] = None,
                 client_secret: Optional[pulumi.Input[str]] = None,
                 extra_ca_certs: Optional[pulumi.Input[str]] = None,
                 master_password: Optional[pulumi.Input[str]] = None,
                 session_key: Optional[pulumi.Input[str]] = None,
                 vault_path: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Provider resource.
        :param pulumi.Input[str] email: Login Email of the Vault (env: `BW_EMAIL`).
        :param pulumi.Input[str] server: Bitwarden Server URL (default: `https://vault.bitwarden.com`, env: `BW_URL`).
        :param pulumi.Input[str] client_id: Client ID (env: `BW_CLIENTID`)
        :param pulumi.Input[str] extra_ca_certs: Extends the well known 'root' CAs (like VeriSign) with the extra certificates in file (env: `NODE_EXTRA_CA_CERTS`).
        :param pulumi.Input[str] session_key: A Bitwarden Session Key (env: `BW_SESSION`)
        :param pulumi.Input[str] vault_path: Alternative directory for storing the Vault locally (default: `.bitwarden/`, env: `BITWARDENCLI_APPDATA_DIR`).
        """
        pulumi.set(__self__, "email", email)
        pulumi.set(__self__, "server", server)
        if client_id is not None:
            pulumi.set(__self__, "client_id", client_id)
        if client_secret is not None:
            pulumi.set(__self__, "client_secret", client_secret)
        if extra_ca_certs is not None:
            pulumi.set(__self__, "extra_ca_certs", extra_ca_certs)
        if master_password is not None:
            pulumi.set(__self__, "master_password", master_password)
        if session_key is not None:
            pulumi.set(__self__, "session_key", session_key)
        if vault_path is not None:
            pulumi.set(__self__, "vault_path", vault_path)

    @property
    @pulumi.getter
    def email(self) -> pulumi.Input[str]:
        """
        Login Email of the Vault (env: `BW_EMAIL`).
        """
        return pulumi.get(self, "email")

    @email.setter
    def email(self, value: pulumi.Input[str]):
        pulumi.set(self, "email", value)

    @property
    @pulumi.getter
    def server(self) -> pulumi.Input[str]:
        """
        Bitwarden Server URL (default: `https://vault.bitwarden.com`, env: `BW_URL`).
        """
        return pulumi.get(self, "server")

    @server.setter
    def server(self, value: pulumi.Input[str]):
        pulumi.set(self, "server", value)

    @property
    @pulumi.getter(name="clientId")
    def client_id(self) -> Optional[pulumi.Input[str]]:
        """
        Client ID (env: `BW_CLIENTID`)
        """
        return pulumi.get(self, "client_id")

    @client_id.setter
    def client_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "client_id", value)

    @property
    @pulumi.getter(name="clientSecret")
    def client_secret(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "client_secret")

    @client_secret.setter
    def client_secret(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "client_secret", value)

    @property
    @pulumi.getter(name="extraCaCerts")
    def extra_ca_certs(self) -> Optional[pulumi.Input[str]]:
        """
        Extends the well known 'root' CAs (like VeriSign) with the extra certificates in file (env: `NODE_EXTRA_CA_CERTS`).
        """
        return pulumi.get(self, "extra_ca_certs")

    @extra_ca_certs.setter
    def extra_ca_certs(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "extra_ca_certs", value)

    @property
    @pulumi.getter(name="masterPassword")
    def master_password(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "master_password")

    @master_password.setter
    def master_password(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "master_password", value)

    @property
    @pulumi.getter(name="sessionKey")
    def session_key(self) -> Optional[pulumi.Input[str]]:
        """
        A Bitwarden Session Key (env: `BW_SESSION`)
        """
        return pulumi.get(self, "session_key")

    @session_key.setter
    def session_key(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "session_key", value)

    @property
    @pulumi.getter(name="vaultPath")
    def vault_path(self) -> Optional[pulumi.Input[str]]:
        """
        Alternative directory for storing the Vault locally (default: `.bitwarden/`, env: `BITWARDENCLI_APPDATA_DIR`).
        """
        return pulumi.get(self, "vault_path")

    @vault_path.setter
    def vault_path(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vault_path", value)


class Provider(pulumi.ProviderResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 client_id: Optional[pulumi.Input[str]] = None,
                 client_secret: Optional[pulumi.Input[str]] = None,
                 email: Optional[pulumi.Input[str]] = None,
                 extra_ca_certs: Optional[pulumi.Input[str]] = None,
                 master_password: Optional[pulumi.Input[str]] = None,
                 server: Optional[pulumi.Input[str]] = None,
                 session_key: Optional[pulumi.Input[str]] = None,
                 vault_path: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        The provider type for the bitwarden package. By default, resources use package-wide configuration
        settings, however an explicit `Provider` instance may be created and passed during resource
        construction to achieve fine-grained programmatic control over provider settings. See the
        [documentation](https://www.pulumi.com/docs/reference/programming-model/#providers) for more information.

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] client_id: Client ID (env: `BW_CLIENTID`)
        :param pulumi.Input[str] email: Login Email of the Vault (env: `BW_EMAIL`).
        :param pulumi.Input[str] extra_ca_certs: Extends the well known 'root' CAs (like VeriSign) with the extra certificates in file (env: `NODE_EXTRA_CA_CERTS`).
        :param pulumi.Input[str] server: Bitwarden Server URL (default: `https://vault.bitwarden.com`, env: `BW_URL`).
        :param pulumi.Input[str] session_key: A Bitwarden Session Key (env: `BW_SESSION`)
        :param pulumi.Input[str] vault_path: Alternative directory for storing the Vault locally (default: `.bitwarden/`, env: `BITWARDENCLI_APPDATA_DIR`).
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ProviderArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        The provider type for the bitwarden package. By default, resources use package-wide configuration
        settings, however an explicit `Provider` instance may be created and passed during resource
        construction to achieve fine-grained programmatic control over provider settings. See the
        [documentation](https://www.pulumi.com/docs/reference/programming-model/#providers) for more information.

        :param str resource_name: The name of the resource.
        :param ProviderArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ProviderArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 client_id: Optional[pulumi.Input[str]] = None,
                 client_secret: Optional[pulumi.Input[str]] = None,
                 email: Optional[pulumi.Input[str]] = None,
                 extra_ca_certs: Optional[pulumi.Input[str]] = None,
                 master_password: Optional[pulumi.Input[str]] = None,
                 server: Optional[pulumi.Input[str]] = None,
                 session_key: Optional[pulumi.Input[str]] = None,
                 vault_path: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ProviderArgs.__new__(ProviderArgs)

            __props__.__dict__["client_id"] = client_id
            __props__.__dict__["client_secret"] = client_secret
            if email is None and not opts.urn:
                raise TypeError("Missing required property 'email'")
            __props__.__dict__["email"] = email
            __props__.__dict__["extra_ca_certs"] = extra_ca_certs
            __props__.__dict__["master_password"] = master_password
            if server is None and not opts.urn:
                raise TypeError("Missing required property 'server'")
            __props__.__dict__["server"] = server
            __props__.__dict__["session_key"] = session_key
            __props__.__dict__["vault_path"] = vault_path
        super(Provider, __self__).__init__(
            'bitwarden',
            resource_name,
            __props__,
            opts)

    @property
    @pulumi.getter(name="clientId")
    def client_id(self) -> pulumi.Output[Optional[str]]:
        """
        Client ID (env: `BW_CLIENTID`)
        """
        return pulumi.get(self, "client_id")

    @property
    @pulumi.getter(name="clientSecret")
    def client_secret(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "client_secret")

    @property
    @pulumi.getter
    def email(self) -> pulumi.Output[str]:
        """
        Login Email of the Vault (env: `BW_EMAIL`).
        """
        return pulumi.get(self, "email")

    @property
    @pulumi.getter(name="extraCaCerts")
    def extra_ca_certs(self) -> pulumi.Output[Optional[str]]:
        """
        Extends the well known 'root' CAs (like VeriSign) with the extra certificates in file (env: `NODE_EXTRA_CA_CERTS`).
        """
        return pulumi.get(self, "extra_ca_certs")

    @property
    @pulumi.getter(name="masterPassword")
    def master_password(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "master_password")

    @property
    @pulumi.getter
    def server(self) -> pulumi.Output[str]:
        """
        Bitwarden Server URL (default: `https://vault.bitwarden.com`, env: `BW_URL`).
        """
        return pulumi.get(self, "server")

    @property
    @pulumi.getter(name="sessionKey")
    def session_key(self) -> pulumi.Output[Optional[str]]:
        """
        A Bitwarden Session Key (env: `BW_SESSION`)
        """
        return pulumi.get(self, "session_key")

    @property
    @pulumi.getter(name="vaultPath")
    def vault_path(self) -> pulumi.Output[Optional[str]]:
        """
        Alternative directory for storing the Vault locally (default: `.bitwarden/`, env: `BITWARDENCLI_APPDATA_DIR`).
        """
        return pulumi.get(self, "vault_path")

